class SQUARE_ABSTRACT
creation make
feature
	map : MAP_ABSTRACT
	location : LOCATION
	put_map(m : like map) is
	do
		map := m
	end
	put_location(l : LOCATION) is
	do
		location := l
	end

	thing : THING_ABSTRACT

	make(m : like map; l : LOCATION) is
	do
		!!layer.make(1, layer_count)
		map := m
		location := l
		if map /= Void and location /= Void then
			map.put_square(Current, location)
		end
	end

	dominant : like thing is
		--returns dominant thing
	local
		i : INTEGER
	do
		from i := layer.upper
		until Result /= Void or else i < layer.lower
		loop
			Result := layer @ i
			i := i - 1
		end
	end

	adjacent(dir : INTEGER) : like Current is
	do
		Result := map.adjacent(Current, dir)
	end

	clear is
	local
		i : INTEGER
	do
		from i := layer.lower
		until i > layer.upper
		loop
			layer.put(Void, i)
			i := i + 1
		end
	end

	layer_count : INTEGER is 3

	layer : ARRAY[like thing]

	move_all_to(other : SQUARE) is
	local
		i : INTEGER
	do
		from i := layer.lower
		until i > layer.upper
		loop
			if other.layer @ i /= Void then
				io.put_string("Uh Oh: overwriting layer(s)!%N")
				die_with_code(1)
			end
			other.layer.put(layer @ i, i)
			layer.put(Void, i)
			i := i + 1
		end
	end
end
