class ENGINE
creation make
feature
	world : MAP

	make is
	do
		!!world.test
		!!player.make(world.start_square)
		player.put_char('@')
		draw_screen
		main_loop
	end
	
	player : MONSTER

	main_loop is
	local
		i : INTEGER
		loc : LOCATION
		quit : BOOLEAN
		sq : SQUARE
	do
		from
		until quit
		loop
			io.read_character
			inspect io.last_character
				when 'q' then
					quit := true
				when 's' then
					loc := player.square.location
					sq := world.map.item(loc.z).item(loc.x, loc.y - 1)
					player.touch_square(sq)
					draw_screen
				when 'n' then
					loc := player.square.location
					sq := world.map.item(loc.z).item(loc.x, loc.y + 1)
					player.touch_square(sq)
					draw_screen
				else
			end
		end
	end

	draw_screen is
	do
		draw_map
	end
	
	draw_map is
	local
		x, y : INTEGER
		sq : SQUARE
	do
		from y := 10
		until y < 1
		loop
			from x := 1
			until x > 20
			loop
				sq := world.map.item(1).item(x,y)
				if sq /= Void then
					if sq.monster = Void then
						io.put_character(sq.things.last.char)
					else
						io.put_character(sq.monster.char)
					end
				else
					io.put_character(' ')
				end
				x := x + 1
			end
			io.put_character('%N')
			y := y - 1
		end
	end
end
