class CHRTOOL
creation make
feature
	width : INTEGER is 8
	height : INTEGER is 14

	table : ARRAY[ARRAY2[BOOLEAN]]
	chr_max : INTEGER is 255

	make is
	local
		a : ARRAY2[BOOLEAN]
		i : INTEGER
	do
		!!table.make(0, chr_max)
		from i := 0
		until i > chr_max
		loop
			!!a.make(1, width, 1, height)
			table.put(a, i)
			i := i + 1
		end
		
		read_chr
	end

	read_chr is
	local
		input : STD_FILE_READ
		finished : BOOLEAN
		bitn : BIT 8
		i, j, n : INTEGER
	do
		!!input.connect_to("ascii.chr")
		from n := 0
			j := 1
			input.read_character
		until finished
		loop
			--io.put_integer(input.last_character.code)
			--io.put_string("%N")
			bitn := input.last_character.to_bit
			from i := width
			until i < 1
			loop
				if bitn.item(i) then
					table.item(n).put(true, i, j)
				end
				i := i - 1
			end
			j := j + 1
			if j > height then
				j := 1
				n := n + 1
			end
			input.read_character
			finished := input.end_of_input
		end
	end

	show_chr is
	local
		i, j, k : INTEGER
	do
		from i := 0
		until i > chr_max
		loop
			from j := 1
			until j > height
			loop
				from k := 1
				until k > width
				loop
					if table.item(i).item(k, j) then
						io.put_character('#')
					else
						io.put_character('.')
					end
					k := k + 1
				end
				io.put_string("%N")
				j := j + 1
			end
			io.put_string("%N")
			i := i + 1
		end
	end
end
