class GEM
inherit
	MONSTER_FLOOR
		redefine
			make,
			shot,
			blast,
			can_push_me,
			can_convey_me,
			player_touch
		end
creation make, make_for_world
feature
	make(sq : SQUARE) is
	do
		Precursor(sq)
		put_chr(4)
	end

	player_touch(p : PLAYER) is
	do
		p.add_gems(1)
		p.add_score(10)
		p.add_health(1)
		die
		p.move_to(square)
	end

	can_push_me(d : INTEGER) : BOOLEAN is
	once
		Result := true
	end
	can_convey_me : BOOLEAN is true

	blast is
	do
		die
	end

	shot(b : BULLET) is
	do
		die
	end

	kind : STRING is "gem"
	zzt_code : INTEGER is 7
end
