class SQUARE
inherit SQUARE_ABSTRACT
	redefine
		map,
		dominant,
		--put_monster,
		thing
	end
creation make
feature
	map : MAP

	thing : THING

	world_adjacent(dir : INTEGER) : like Current is
	do
		Result := map.world_adjacent(Current, dir)
	end

	terrain_layer : INTEGER is 1
	monster_layer : INTEGER is 2

	put_terrain(t : TERRAIN) is
	do
		if layer @ terrain_layer /= Void then
			io.put_string("Uh oh: overwriting terrain%N")
			--die_with_code(1)
		end
		layer.put(t, terrain_layer)
	end

	remove_monster is
	do
		if layer @ monster_layer = Void then
			io.put_string("Uh oh: removing monster when there isn't one%N")
			--die_with_code(1)
		end
		layer.put(Void, monster_layer)
		monster := Void
	end
	put_monster(m : MONSTER) is
	do
		if layer @ monster_layer /= Void then
			io.put_string("Uh oh: overwriting monster%N")
			die_with_code(1)
		end
		layer.put(m, monster_layer)
		monster := m
	end
	monster : MONSTER

	put_sentinel(s : SENTINEL) is
	do
		layer.put(s, 2)
		layer.put(s, 1)
	end

	dominant : like thing is
	do
		Result := Precursor
		if Result = Void then
			io.put_string("Uh oh: dominant = Void!%N")
			io.put_string("Board #")
			io.put_integer(map.world.board_list.index_of(map))
			if location /= Void then
				io.put_string(" (")
				io.put_integer(location.x)
				io.put_string(", ")
				io.put_integer(location.y)
				io.put_string(")%N")
			else
				io.put_string("Void%N")
			end
			die_with_code(1)
		end
	end
end
