deferred class TICKABLE
inherit
	MONSTER_OBJECT
		redefine
			tick,
			read_init,
			die
		end
feature
	cycle : INTEGER

	tick is
	do
		if cycle_count >= cycle then
			cycle_tick
			cycle_count := 1
		else
			cycle_count := cycle_count + 1
		end
	end

	read_init(header : OBJECT_HEADER) is
	do
		cycle := header.cycle
		-- I wonder what the real formula is
		cycle_count := cycle - ((header.object_number - 1) \\ cycle)
		ticker_on
		read_init_rest(header)
	end

	read_init_rest(header : OBJECT_HEADER) is
	deferred
	end
	
	cycle_tick is
	deferred
	end

	ticker_on is
	do
		put_ticking(true)
	end

	die is
	do
		ticker_off
		Precursor
	end

	ticker_off is
	do
		put_ticking(false)
	end

feature {NONE}
	cycle_count : INTEGER
end
