class SCROLL
inherit
	OBJECT
		redefine
			die,
			make,
			kind,
			zzt_code,
			add_to_map,
			read_init_rest,
			cycle_tick,
			can_push_me,
			can_convey_me,
			player_touch
		end
	KNOWS_MASTER
creation make, make_for_world
feature
	make(sq : SQUARE) is
	do
		Precursor(sq)
		put_chr(232)
	end

	read_init_rest(header : OBJECT_HEADER) is
	do
		current_offset := header.ins + 1
		read_program(header.data)
		!!id.copy("Scroll")
	end

	can_push_me(d : INTEGER) : BOOLEAN is
	once
		Result := true
	end

	can_convey_me : BOOLEAN is true

	player_touch(p : PLAYER) is
	do
		execute_one_tick
		die
		p.move_to(square)
	end

	cycle_tick is
	do
		if colour = 15 then
			put_colour(9)
		else
			put_colour(colour + 1)
		end
	end

	lines : ARRAY[STRING] is
	local
		i, j : INTEGER
		size : INTEGER
		hitcr : BOOLEAN
		line : STRING
	do
		size := 0
		from i := 1
		until i > program.count
		loop
			if program.item(i) = '%R' then
				size := size + 1
			end
			i := i + 1
		end

		io.put_string("String size: ")
		io.put_integer(program.count)
		io.put_string("%N")
		io.put_string("Lines: ")
		io.put_integer(size)
		io.put_string("%N")
		!!Result.make(1, size)
		from
			i := 1
			j := 1
		until i > size
		loop
			!!line.make(0)
			hitcr := false
			from
			until hitcr
			loop
				if program.item(j) = '%R' then
					hitcr := true
				else
					line.add_last(program.item(j))
				end
				j := j + 1
			end
			Result.put(line, i)
			i := i + 1
		end
	end

	kind : STRING is "scroll"
	zzt_code : INTEGER is 10

	add_to_map(m : MAP; sq : SQUARE; c : INTEGER) is
	local
		t : like Current
	do
		t := clone(Current)
		t.put_colour(c)
		t.make(sq)
	end

	die is
	do
		old_die
	end
end
